---
title: ReadableStreamBYOBReader.read()
slug: Web/API/ReadableStreamBYOBReader/read
tags:
  - API
  - Experimental
  - Method
  - ReadableStreamBYOBReader
  - Reference
  - Streams
  - read
---
<div>{{draft}}{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>read()</code></strong> method of the {{domxref("ReadableStreamBYOBReader")}} interface returns a promise providing access to the next chunk in the byte stream's internal queue.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>readableStreamBYOBReader</em>.read(<em>view</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>view</dt>
 <dd>The view to be read into.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}}, which fulfills/rejects with a result depending on the state of the stream. The different possibilities are as follows:</p>

<ul>
 <li>If a chunk is available, the promise will be fulfilled with an object of the form <code>{ value: theChunk, done: false }</code>.</li>
 <li>If the stream becomes closed, the promise will be fulfilled with an object of the form <code>{ value: undefined, done: true }</code>.</li>
 <li>If the stream becomes errored, the promise will be rejected with the relevant error.</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The source object is not a <code>ReadableStreamBYOBReader</code>, the stream has no owner, the view is not an object or has become detached, or the view's length is 0.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>TBD.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#byob-reader-read","read()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStreamBYOBReader.read")}}</p>
